require "lope2d"
require "gooi"
require "utils"
candy = require "candy"
k     = require "katsudo"
flux  = require "flux"

function love.load()
    gr = love.graphics
    kb = love.keyboard
    mo = love.mouse
    to = love.touch
    ma = love.math
    au = love.audio
    fs = love.filesystem
    im = love.image

    fs.setIdentity("the_lord_of_candies")

    -- highscore data:
    fileNameHS = "records.lord"

    if not fs.exists(fileNameHS) then
        local stringData = "records = {"

        for i = 1, 4 do
            stringData = stringData..
            "    {\n"..
            "        score = 0,\n"..
            "        name = \"---\"".."\n"..
            "    },"
        end

        stringData = stringData.."}"

        local compressedData = ma.compress(stringData, "gzip")

        local writeOK = fs.write(fileNameHS, compressedData)
        --[[
        local stringData = "records = {\n"

        for i = 1, 4 do
            stringData = stringData..
            "    {\n"..
            "        score = 0,\n"..
            "        name = \"---\"".."\n"..
            "    },"
        end

        stringData = stringData.."\n}"

        local writeOK = fs.write(fileNameHS, stringData)
        ]]

    end


    --[[
    local data, size = fs.read(fileNameHS)
    decompressed = ma.decompress(data, "gzip")

    loadstring(decompressed)()

    print_r(records)
    ]]


    gr.setLineWidth(2)
    gr.setLineStyle("rough")

    colors = {
        black = {0, 0, 0},
        darkGray = {48, 48, 48},
        white = {248, 248, 248},
        red = {208, 16, 0},
        green = {0, 104, 0},
        lightGreen = {40, 192, 32},
        softBlue = {80, 120, 248},
        orange = {248, 128, 24},
        gold = {192, 152, 0}
    }

    dirImgs = "/assets/imgs/"
    dirFonts = "/assets/fonts/"
    dirAudio = "/assets/audio/"
    kinds = {"red", "green", "blue"}
    places = {"st", "nd", "rd", "th", "th", "th"}

    -- canvas stuff:
    win = {w = gr.getWidth(), h = gr.getHeight()}
    canvasW = 280 --144
    canvasH = 210 --256
    canvas = gr.newCanvas(canvasW, canvasH, "normal")
    sx = win.w / canvasW -- x scale
    sy = win.h / canvasH -- y scale

    accelCandyTime = 0.02
    cr = 13 -- candy radius
    crSmall = 8
    initDelayEnterCandy = 2.2
    delayEnterCandy = initDelayEnterCandy
    amountToMove = 30
    delayGameOver = 3
    delayScoreScreen = 2.5
    initHP = 6
    hp = initHP
    indexCandy = 0
    indexTitlePixel = 1
    maxCandies = 160
    minDelayEnterCandy = 0.4
    minimumForHighScore = 10
    points = 0
    randomSpecialItem()
    timerEnterCandy = 0
    timerGameOver = 0
    timerMoveTitle = 0
    timerScoreScreen = 0
    wt = 100 -- wall thickness
    yQuadHearts = 0

    musicLevel = 0.7
    sfxLevel = 0.7

    MOUSE_LEFT = 1
    MOUSE_RIGHT = 2
    MOUSE_MIDDLE = 3

    STATE_MENU = 1
    STATE_GAME = 2
    STATE_GAME_OVER = 3
    STATE_CREDITS = 4
    STATE_OPTIONS = 5
    STATE_HS = 6
    STATE_DONATIONS = 7
    STATE_HELP = 8

    state = STATE_MENU
    timerZeroGrav = 0
    delayZeroGrav = 8
    endingScoreScreen = false
    zeroGravActivated = false
    paused = false
    dbwc = false -- death by wrong candy
    dbtu = false -- death by time up
    timerDBWC = 0
    delayDBWC = 3
    timerDBTU = 0
    delayDBTU = 3

    --ball = lope.newBody("dynamic", "circle", canvasW / 2, canvasH / 2, 10)
    candies = {}
    candiesBeingEaten = {}
    font = gr.newFont(dirFonts.."emulogic.ttf", 8)
    fontBig = gr.newFont(dirFonts.."emulogic.ttf", 16)
    fontProggy = gr.newFont(dirFonts.."ProggyTiny.ttf", 16)
    gr.setFont(font)

    wallTop     = lope.newBody("static", "rectangle", canvasW / 2, -wt / 2, canvasW, wt)
    wallBottom  = lope.newBody("static", "rectangle", canvasW / 2, canvasH + wt * 0.45, canvasW, wt)
    wallLeft    = lope.newBody("static", "rectangle", -wt / 2, canvasH / 2, wt, canvasH + wt * 2)
    wallRight   = lope.newBody("static", "rectangle", canvasW + wt / 2, canvasH / 2, wt, canvasH + wt * 2)




    imgRedCandy   = gr.newImage(dirImgs.."redCandy.png")
    imgGreenCandy = gr.newImage(dirImgs.."greenCandy.png")
    imgBlueCandy  = gr.newImage(dirImgs.."blueCandy.png")
    imgRedCandySmall   = gr.newImage(dirImgs.."redCandySmall.png")
    imgGreenCandySmall = gr.newImage(dirImgs.."greenCandySmall.png")
    imgBlueCandySmall  = gr.newImage(dirImgs.."blueCandySmall.png")
    imgRing       = gr.newImage(dirImgs.."ring.png")
    imgClock      = gr.newImage(dirImgs.."clock.png")
    imgTimer      = gr.newImage(dirImgs.."timer.png")
    imgRedLeds    = gr.newImage(dirImgs.."redLeds.png")
    imgGreenLeds  = gr.newImage(dirImgs.."greenLeds.png")
    imgBlueLeds   = gr.newImage(dirImgs.."blueLeds.png")
    imgLogo       = gr.newImage(dirImgs.."logo.png")
    imgHearts     = gr.newImage(dirImgs.."hearts.png")
    imgGrass      = gr.newImage(dirImgs.."grass.png")
    imgCredits    = gr.newImage(dirImgs.."credits.png")
    imgOptions    = gr.newImage(dirImgs.."options.png")
    imgHalo       = gr.newImage(dirImgs.."halo.png")
    imgHaloSmall  = gr.newImage(dirImgs.."haloSmall.png")
    imgGrid       = gr.newImage(dirImgs.."grid.png")
    imgGmail      = gr.newImage(dirImgs.."gmail.png")
    imgFB         = gr.newImage(dirImgs.."fb.png")
    imgYouTube    = gr.newImage(dirImgs.."youtube.png")
    imgTwitter    = gr.newImage(dirImgs.."twitter.png")
    imgRightCandy = gr.newImage(dirImgs.."rightCandy.png")
    imgRightCandySmall = gr.newImage(dirImgs.."rightCandySmall.png")
    imgCBE        = gr.newImage(dirImgs.."cbe.png")
    imgCBESmall   = gr.newImage(dirImgs.."cbeSmall.png")
    img           = gr.newImage(dirImgs.."cbe.png")
    imgGrass:setWrap("repeat", "repeat")
    imgGrid: setWrap("repeat", "repeat")

    quadHearts    = gr.newQuad(0, 0, 23, 7, imgHearts:getWidth(), imgHearts:getHeight())
    quadGrass     = gr.newQuad(0, 0, canvasW, imgGrass:getHeight(), imgGrass:getWidth(), imgGrass:getHeight())
    quadGrid      = gr.newQuad(0, 0, canvasW, canvasH, imgGrid:getWidth(), imgGrid:getHeight())

    animSelected      = k.new(dirImgs.."selected.png", 32, 32, 2, 0.07)
    animSelectedSmall = k.new(dirImgs.."selectedSmall.png", 22, 22, 2, 0.07)
    animSpecial       = k.new(dirImgs.."special.png", 26, 26, 4, 0.07)
    animSpecialSmall  = k.new(dirImgs.."specialSmall.png", 16, 16, 4, 0.07)
    animZG            = k.new(dirImgs.."zg.png", 26, 26, 4, 0.07)
    animZGSmall       = k.new(dirImgs.."zgSmall.png", 16, 16, 4, 0.07)
    animShrinker      = k.new(dirImgs.."shrinker.png", 26, 26, 4, 0.07)
    animShrinkerSmall = k.new(dirImgs.."shrinkerSmall.png", 16, 16, 4, 0.07)

    imgDataTitle = im.newImageData(dirImgs.."title.png")

    musicMenu     = au.newSource(dirAudio.."musicMenu.ogg", "stream")
    musicGame     = au.newSource(dirAudio.."musicGame.ogg", "stream")
    musicGameOver = au.newSource(dirAudio.."musicGameOver.ogg", "stream")
    soundDBWC     = au.newSource(dirAudio.."soundDBWC.ogg", "static")
    soundPoint    = au.newSource(dirAudio.."soundPoint.ogg", "static")
    soundZG       = au.newSource(dirAudio.."soundZG.ogg", "static")
    soundShrinker = au.newSource(dirAudio.."soundShrinker.ogg", "static")
    soundSpecial  = au.newSource(dirAudio.."soundSpecial.ogg", "static")

    musicMenu:setLooping(true)
    musicGame:setLooping(true)
    musicGameOver:setLooping(true)

    changeMusicLevel(musicLevel)
    changeSFXLevel(sfxLevel)

    -- title animation:
    pixelsTitle = {}
    imgX = math.floor(canvasW / 2 - imgDataTitle:getWidth())
    imgY = 24
    imgW = imgDataTitle:getWidth()
    imgH = imgDataTitle:getHeight()
    for y = 1, imgH do
        for x = 1, imgW do
            local col = {imgDataTitle:getPixel(x - 1, y - 1)}

            if col[4] > 0 then
                table.insert(pixelsTitle, {
                    x = imgX + (x - 1) * 2,
                    y = imgY + (y - 1) * 2,
                    initX = ma.random(0, canvasW),
                    initY = ma.random(0, canvasH),
                    color = col
                })
            end
        end
    end
    shuffle(pixelsTitle)
    --print(#pixelsTitle)

    -- clock:

    clock = {
        img = imgClock,
        angle = 0,
        x = canvasW * .15,
        y = 35,
        speed = 20 -- degrees per second
    }

    ring = {
        img = imgRing,
        x = canvasW * .5,
        y = 35,
        radius = 15,
        state = "red" -- capturing red candy
    }

    timer = {
        img = imgTimer,
        initTime = 20, -- seconds
        x = canvasW * .85,
        y = 35,
        speed = 0.7
    }
    timer.time = timer.initTime


    -- menu:
    gooi.setStyle({
        font = font,
        showBorder = false,
        bgColor = colors.softBlue
    })
    gooi.desktopMode()
    gooi.setCanvas(canvas)
    
    btnStart = gooi.newButton({text = "go"})
    :onRelease(function()
        musicMenu:stop()
        musicGame:play()
        state = STATE_GAME

        gooi.setGroupVisible("menu", false)
    end)
    --:setIcon(imgLogo)
    :center()
    btnStart.style.font = fontBig

    --lblMenu = gooi.newLabel({text = "The Lord\nof\ncandies"}):center()
    --:setOpaque(true)

    btnCredits = gooi.newButton({text = "", icon = imgCredits})
    btnCredits.style.bgColor = colors.orange
    btnCredits:onRelease(function()
        gooi.setGroupVisible("menu", false)
        gooi.setGroupVisible("credits", true)
        state = STATE_CREDITS
    end)

    btnOptions = gooi.newButton({text = "", icon = imgOptions})
    btnOptions.style.bgColor = colors.lightGreen
    btnOptions:onRelease(function()
        state = STATE_OPTIONS
        gooi.setGroupVisible("options", true)
        gooi.setGroupVisible("menu", false)
    end)

    panelMenu = gooi.newPanel({
      x = 0,
      y = 170,
      w = canvasW,
      h = canvasH - 170,
      layout = "grid 1x5"
    })
    --panelMenu.layout.debug = true
    -- title

    btnDonations = gooi.newButton({text = "", icon = dirImgs.."contact2.png"})
    btnDonations:onRelease(function()
        state = STATE_DONATIONS
        gooi.setGroupVisible("menu", false)
        gooi.setGroupVisible("donations", true)
    end)

    btnHelp = gooi.newButton({text = "", icon = dirImgs.."question.png"})
    :onRelease(function()
        state = STATE_HELP
        gooi.setGroupVisible("menu", false)
        gooi.setGroupVisible("help", true)
    end)
    :bg(colors.red)

    panelMenu:add(
        btnStart,
        btnCredits,
        btnOptions,
        btnDonations,
        btnHelp
    ):setGroup("menu")

    -- options:
    lblMusic = gooi.newLabel({text = "Music level:"}):left()
    sliMusic = gooi.newSlider({value = musicLevel}):bg(colors.green)
    lblSFX   = gooi.newLabel({text = "SFX level:"}):left()
    sliSFX   = gooi.newSlider({value = sfxLevel}):bg(colors.orange)
    panelOptions = gooi.newPanel({
        x = 0,
        y = 0,
        w = canvasW,
        h = canvasH,
        layout = "grid 8x1"
    })

    panelOptions:add(
        lblMusic,
        sliMusic,
        lblSFX,
        sliSFX
    )

    sliMusic.w = 200
    sliSFX.w = 200

    btnBackOpt = gooi.newButton({text = "return"}):onRelease(function()
        state = STATE_MENU
        gooi.setGroupVisible("menu", true)
        gooi.setGroupVisible("options", false)
    end)

    panelOptions:add(btnBackOpt, "8,1")
    panelOptions:setGroup("options")
    btnBackOpt.w = 100
    -- game over:

    lblGameOver = gooi.newLabel({text = "Game Over", x = 0, y = 30, w = canvasW, h = 40})
    :setGroup("gameover")
    :center()
    lblGameOver.style.font = fontBig


    -- credits:

    lblCredits = gooi.newLabel({
        text = "Music by:\nErick Skiff\n(ericskiff.com)\nUnder CC",
    }):center()--:setOpaque(true)

    lblCreditsSnds = gooi.newLabel({
        text = "Sounds by:\nLittleRobot\nSoundFactory\n(www.littlerobot\nsoundfactory.com)\nUnder CC",
    }):center()--:setOpaque(true)

    lblCredits2 = gooi.newLabel({
        text = "Art:\nThe Lord\nof the Bits\nunder MIT"
    }):center()--:setOpaque(true)

    lblCredits3 = gooi.newLabel({
        text = "Programming:\nThe Lord\nof the Bits\nunder MIT"
    }):center()--:setOpaque(true)


    panelCredits = gooi.newPanel({
        x = 0,
        y = 0,
        w = canvasW,
        h = canvasH,
        layout = "grid 3x2"
    })


    btnBack = gooi.newButton({x = 200, y = 180, text = "return"})
    :onRelease(function()
        state = STATE_MENU
        gooi.setGroupVisible("menu", true)
        gooi.setGroupVisible("credits", false)
    end)
    btnBack.w = 100
    btnBack.x = 170
    CC = ""
    lblLicense = gooi.newLabel({x = 2, y = 160, text = CC}):setGroup("credits")
    lblLicense:left()
    lblLicense.style.font = fontProggy

    --[[
    btnLicense = gooi.newButton({y = 180, text = "copy licenses"})
    :onRelease(function(c)
        love.system.setClipboardText(CC)
        c:setText("Links copied!"):bg(colors.orange)
    end)
    ]]

    panelCredits:add(lblCredits)
    panelCredits:add(lblCreditsSnds)
    panelCredits:add(lblCredits2)
    panelCredits:add(lblCredits3)

    --btnLicense:setGroup("credits")
    btnBack:setGroup("credits")

    panelCredits:setGroup("credits")

    -- pause GUI:

    btnContinue = gooi.newButton({text = "continue"}):onRelease(function()
        gooi.setGroupVisible("pause", false)
        paused = not paused
    end):bg(colors.lightGreen)
    btnExit = gooi.newButton({text = "exit"}):bg(colors.red):onRelease(function()
        quit()
    end)

    panelPause = gooi.newPanel({
      x = 0,
      y = 100,
      w = canvasW,
      h = 30,
      layout = "grid 1x3"
    })

    btnMainMenu = gooi.newButton({text = "menu"}):onRelease(function()
        state = STATE_MENU
        gooi.setGroupVisible("pause", false)
        gooi.setGroupVisible("menu", true)
        paused = false
        musicGame:stop()
        musicMenu:play()
        clearStuff()
    end)

    panelPause:add(btnMainMenu)
    panelPause:add(btnContinue)
    panelPause:add(btnExit)

    panelPause:setGroup("pause")

    -- high scores gooi:
    textHighScoreNames = getTextHSNames()
    textHighScore = getTextHS()

    lblHighScores = gooi.newLabel({
        text = textHighScore
    }):left()

    lblHighScores2 = gooi.newLabel({
        text = textHighScoreNames
    }):left()

    panelHS = gooi.newPanel({x = 0, y = 0, w = canvasW, h = canvasH, layout = "grid 6x2"})
    panelHS:setColspan(1, 1, 2)
    panelHS:setColspan(2, 1, 2)
    panelHS:setColspan(4, 1, 2)

    lblPlace = gooi.newLabel({text = ""}):center()
    panelHS:add(lblPlace)

    lblPoints = gooi.newLabel({text = ""}):center()
    panelHS:add(lblPoints)

    lblOldTop = gooi.newLabel({text = "top:"}):left()

    panelHS:add(lblOldTop, "4,1")
    panelHS:add(lblHighScores2, "5,1")
    panelHS:add(lblHighScores, "5,2")

    textRecord = gooi.newText()

    panelHS:add(textRecord)
    textRecord.x = 70
    textRecord.w = 65
    textRecord.style.font = fontBig
    btnSendRecord = gooi.newButton({
        text = "ok"
    }):onRelease(function(c)
        endingScoreScreen = true
        
        c:setEnabled(false)

        recordToSet.score = points
        recordToSet.name = textRecord:getText()

        saveRecords(records)
        musicGameOver:stop()
        musicMenu:play()

        local newNames  = getTextHSNames()
        local newScores = getTextHS()

        lblHighScores:setText(newScores)
        lblHighScores2:setText(newNames)
    end)
    panelHS:add(btnSendRecord)
    btnSendRecord.w = 65
    
    panelHS:setGroup("hs")

    gooi.setGroupVisible("hs", false)

    -- donations:
    panelSocial = gooi.newPanel({x = 0, y = 0, w = canvasW, h = canvasH, layout="grid 8x1"})
    lblLike = gooi.newLabel({text = "If you like our stuff,\nlet us know!"}):center()

    panelSocial:add(
        lblLike,
        "2,1"
    )
    lblTwitter = gooi.newLabel({text = "@TLOTB3", icon = imgTwitter}):left()
    panelSocial:add(lblTwitter, "4,1")

    lblFB = gooi.newLabel({text = "/thelordofthebits", icon = imgFB}):left()
    panelSocial:add(lblFB, "5,1")

    lblYouTube = gooi.newLabel({text = "(link pending)", icon = imgYouTube}):left()
    panelSocial:add(lblYouTube, "6,1")

    lblGmail = gooi.newLabel({text = "thelordofthebits3", icon = imgGmail}):left()
    panelSocial:add(lblGmail, "7,1")

    btnReturnSocial = gooi.newButton({text = "return"}):onRelease(function()
        state = STATE_MENU
        gooi.setGroupVisible("donations", false)
        gooi.setGroupVisible("menu", true)
    end)

    panelSocial:add(
        btnReturnSocial,
        "8,1"
    )
    btnReturnSocial.w = 100

    panelSocial:setGroup("donations")

    -- help:
    panelHelp = gooi.newPanel({x = 0, y = 0, w = canvasW, h = canvasH, layout = "grid 8x2"})

    panelHelp:add(gooi.newLabel({text = "Normal candy\n1 point each"}):left(), "3,1")
    panelHelp:add(gooi.newLabel({text = "Special ones\nno points/time"}):left(), "3,2")
    panelHelp:add(gooi.newLabel({text = "that's it"}):left(), "6,1")
    btnReturnHelp = gooi.newButton({text = "return"}):onRelease(function()
        state = STATE_MENU
        gooi.setGroupVisible("menu", true)
        gooi.setGroupVisible("help", false)
    end)
    panelHelp:add(btnReturnHelp, "8,1")
    btnReturnHelp.w = 100
    panelHelp:setGroup("help")

    gooi.setGroupVisible("pause", false)
    gooi.setGroupVisible("options", false)
    gooi.setGroupVisible("credits", false)
    gooi.setGroupVisible("donations", false)
    gooi.setGroupVisible("help", false)

    -- music:
    musicMenu:play()
end








--##############################################
--##############################################
-- update
--##############################################
--##############################################

function love.update(dt)
    gooi.update(dt)
    flux.update(dt)
    
    if state == STATE_MENU then
        -- move title pixels:
        timerMoveTitle = timerMoveTitle + dt

        if timerMoveTitle >= 0.1 then
            timerMoveTitle = 0
            for i = indexTitlePixel, indexTitlePixel + amountToMove do
                local p = pixelsTitle[i]

                if p then
                    flux.to(p, 4, {initX = p.x, initY = p.y}):ease("elasticinout")
                end

            end
            indexTitlePixel = indexTitlePixel + amountToMove
        end
    elseif state == STATE_GAME then
        if not paused then
            if dbwc then
                timerDBWC = timerDBWC + dt

                if timerDBWC >= delayDBWC then
                    timerDBWC = 0
                    dbwc = false

                    gameover()
                end
            elseif dbtu then
            	timerDBTU = timerDBTU + dt

            	if timerDBTU >= delayDBTU then
            		timerDBTU = 0
            		dbtu = false
            		gameover()
            	end
            else
                -- cero gravity:
                if zeroGravActivated then
                    timerZeroGrav = timerZeroGrav + dt
                    if timerZeroGrav >= delayZeroGrav then
                        timerZeroGrav = 0
                        zeroGravActivated = false
                        WORLD:setGravity(
                            WORLD_GRAVITY.x * WORLD_METER,
                            WORLD_GRAVITY.y * WORLD_METER
                        )
                    end
                end

                -- update candies being eaten:
                for i = #candiesBeingEaten, 1, -1 do
                    local candy = candiesBeingEaten[i]
                    candy.lifeTime = candy.lifeTime + dt

                    if candy.lifeTime > candy.delayMove * 1.5 then
                        table.remove(candiesBeingEaten, i)
                    end
                end


                lope.update(dt)
                k.update(dt)

                timerEnterCandy = timerEnterCandy + dt

                if timerEnterCandy >= delayEnterCandy then
                    timerEnterCandy = 0

                    if #candies <= maxCandies then
                        local newCandy = candy.new(
                            ma.random(cr, cr + 4),
                            cr,
                            cr,
                            kinds[ma.random(1, #kinds)]
                        )

                        newCandy.body = lope.newBody(
                            "dynamic",
                            "circle",
                            newCandy.x,
                            newCandy.y,
                            newCandy.radius
                        )
                        newCandy.body:setRestitution(0.2)
                        newCandy.body:applyLinearImpulse(0, 30)

                        table.insert(candies, newCandy)
                        indexCandy = indexCandy + 1

                        -- make it special
                        if indexCandy == howManyToSpecial then
                            randomSpecialItem()
                            indexCandy = 0
                            local num = ma.random(1, 3)

                            if num == 1 then
                                newCandy.kind = "special"
                            elseif num == 2 then
                                newCandy.kind = "zg" 
                            else
                                newCandy.kind = "shrinker"
                            end
                        end
                    end
                end

                -- update candies:
                for k, candy in ipairs(candies) do
                    candy.x, candy.y = candy.body:getX(), candy.body:getY()
                    candy.radius = candy.body:getRadius()
                end

                -- clock:
                clock.angle = clock.angle + dt * clock.speed
                if clock.angle >= 360 then
                    clock.angle = 0
                end

                -- timer:
                timer.time = timer.time - dt * timer.speed
                if timer.time <= 0 then
                	timer.time = 0
                    dbtu = true
                    musicGame:stop()
                    soundDBWC:play()
                end

                -- candy time:
                delayEnterCandy = delayEnterCandy - dt * accelCandyTime
                if delayEnterCandy <= minDelayEnterCandy then
                    delayEnterCandy = minDelayEnterCandy
                end

                -- main collision:
                for i = #candies, 1, -1 do
                    local candy = candies[i]

                    local dx = candy.x - ring.x
                    local dy = candy.y - ring.y
                    local hyp = math.sqrt(math.pow(dx, 2) + math.pow(dy, 2))

                    if hyp < ring.radius then
                        candy.body.body:destroy()
                        
                        -- add a candy being eaten:
                        local cbe = {
                            x = candy.x,
                            y = candy.y,
                            lifeTime = 0,
                            delayMove = 1,
                            small = candy.small
                        };
                        table.insert(candiesBeingEaten, cbe);
                        flux.to(cbe, cbe.delayMove, {x = ring.x, y = ring.y})

                        table.remove(candies, i)


                        if candy.kind ~= ring.state then
                            if candy.kind == "special" then
                                soundSpecial:play()
                                removeCandyOfColor(ring.state)
                                break
                            elseif candy.kind == "shrinker" then
                                soundShrinker:play()
                                shrinkAll()
                                break
                            elseif candy.kind == "zg" then
                                soundZG:play()
                                zeroGrav()
                                break
                            else
                                -- wrong candy: 
                                hp = hp - 1
                                love.system.vibrate(0.4)
                                yQuadHearts = yQuadHearts + 7
                                quadHearts:setViewport(0, yQuadHearts, 23, 7)
                                soundDBWC:play()
                                cbe.wasWrong = true

                                if hp == 0 then
                                  dbwc = true
                                  musicGame:stop()
                                  soundDBWC:play()
                                  break
                                end
                            end
                        else
                            points = points + 1
                            soundPoint:play()
                            -- only normal candies recover the time:
                            timer.time = timer.initTime
                        end
                    end
                end
            end
        end
    elseif state == STATE_GAME_OVER then
        timerGameOver = timerGameOver + dt
        if timerGameOver >= delayGameOver then
            timerGameOver = 0
            state = STATE_MENU
            gooi.setGroupVisible("menu", true)

            musicGameOver:stop()
            musicMenu:play()
        end
    elseif state == STATE_OPTIONS then
        gooi.update(dt)
        changeMusicLevel(sliMusic:getValue())
        changeSFXLevel(sliSFX:getValue())
    elseif state == STATE_HS then
        if endingScoreScreen then
            timerScoreScreen = timerScoreScreen + dt

            if timerScoreScreen >= delayScoreScreen then
                timerScoreScreen = 0
                endingScoreScreen = false

                gooi.setGroupVisible("hs", false)
                gooi.setGroupVisible("menu", true)
                state = STATE_MENU
                points = 0
                btnSendRecord:setEnabled(true)
            end
        end
    elseif state == STATE_HELP then
        k.update(dt)
    end
end












--##############################################
--##############################################
-- draw
--##############################################
--##############################################

function love.draw()
    gr.setColor(colors.white)
    gr.setCanvas(canvas)

    gr.setColor(colors.black)
    gr.rectangle("fill", 0, 0, canvasW, canvasH)

    if state == STATE_MENU then
        gooi.draw("menu")
        -- draw title:
        for i = 1, #pixelsTitle do
            local p = pixelsTitle[i]

            gr.setColor(p.color)
            gr.rectangle("fill", p.initX, p.initY, 2, 2)
        end

        if paused then
            gr.draw(imgGrid, quadGrid, 0, 0)
            gooi.draw("pause")
        end
    elseif state == STATE_CREDITS then
        gooi.draw("credits")
    elseif state == STATE_GAME then
        --debug:
        gr.setFont(font)
        gr.setColor(colors.softBlue)

        if dbwc or dbtu then
            gr.setColor(colors.orange)
        end

        gr.rectangle("fill", 0, 0, canvasW, canvasH)
        --lope.draw(ball)
        gr.setColor(colors.white)

        -- grass:
        if dbwc or dbtu then
            gr.setColor(colors.black)
        end
        gr.draw(imgGrass, quadGrass, 0, canvasH - imgGrass:getHeight())

        -- candies being eaten:
        for i = 1, #candiesBeingEaten do
            local candy = candiesBeingEaten[i]
            local imgC = imgRightCandy

            if candy.small then
                imgC = imgRightCandySmall
            end

            if candy.wasWrong then
                imgC = imgCBE

                if candy.small then
                    imgC = imgCBESmall
                end
            end

            gr.draw(imgC,
                math.floor(candy.x),
                math.floor(candy.y),
                0, 1, 1,
                imgC:getWidth() / 2,
                imgC:getHeight() / 2
            )
        end

        -- draw candies:
        for k, candy in ipairs(candies) do
            gr.setColor(colors.red)
            if candy.selected then
                gr.setColor(colors.lightGreen)
            end
            --gr.circle("line", candy.x, candy.y, candy.radius)
            gr.setColor(colors.white)

            if dbwc or dbtu then
                gr.setColor(colors.black)
            end
            local img = imgRedCandy
            if candy.kind == "red" then
                img = imgRedCandy
                if candy.small then
                    img = imgRedCandySmall
                end
            elseif candy.kind == "green" then
                img = imgGreenCandy
                if candy.small then
                    img = imgGreenCandySmall
                end
            elseif candy.kind == "blue" then
                img = imgBlueCandy
                if candy.small then
                    img = imgBlueCandySmall
                end
            end

            if candy.selected then
                local anim = animSelected
                if candy.small then anim = animSelectedSmall end
                anim:draw(
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, anim.w / 2, anim.h / 2
                )
            end

            if candy.kind == "special" then
                local anim = animSpecial
                if candy.small then anim = animSpecialSmall end
                anim:draw(
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, anim.w / 2, anim.h / 2
                )
            elseif candy.kind == "shrinker" then
                local anim = animShrinker
                if candy.small then anim = animShrinkerSmall end
                anim:draw(
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, anim.w / 2, anim.h / 2
                )
            elseif candy.kind == "zg" then
                local anim = animZG
                if candy.small then anim = animZGSmall end
                anim:draw(
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, anim.w / 2, anim.h / 2
                )
            else
                gr.draw(img,
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, img:getWidth() / 2, img:getHeight() / 2)
            end

            if zeroGravActivated then
                local halo = imgHalo
                if candy.small then halo = imgHaloSmall end
                gr.draw(halo,
                    math.ceil(candy.x),
                    math.ceil(candy.y),
                    0, 1, 1, halo:getWidth() / 2, halo:getHeight() / 2
                )
            end

            if mo.isDown(MOUSE_LEFT) then
                local selectedCandy = getSelectedCandy()

                if selectedCandy then
                    gr.line(
                        selectedCandy.x,
                        selectedCandy.y,
                        mo.getX() / sx,
                        mo.getY() / sy)
                end
            end
        end

        gr.setColor(colors.white)
        -- hearts:
        gr.draw(imgHearts, quadHearts,
            math.ceil(canvasW / 2 - imgHearts:getWidth() / 2),
            3,
            0, 1, 1
        )

        -- clock:
        gr.draw(clock.img,
            math.floor(clock.x),
            math.floor(clock.y),
            0, 1, 1,
            clock.img:getWidth() / 2,
            clock.img:getHeight() / 2
        )

        -- center:
        gr.setColor(colors.black)
        gr.circle(
            "fill",
            math.floor(clock.x), 
            math.floor(clock.y),
            10,
            80
        )

        -- clock arrow:
        gr.setColor(colors.white)
        gr.line(
            math.floor(clock.x),
            math.floor(clock.y),
            clock.x + 12 * math.cos(math.rad(clock.angle - 90)),
            clock.y + 12 * math.sin(math.rad(clock.angle - 90))
        )

        -- goal ring:
        gr.draw(ring.img,
            math.floor(ring.x),
            math.floor(ring.y),
            0, 1, 1,
            ring.img:getWidth() / 2,
            ring.img:getHeight() / 2)

        -- leds:
        gr.draw(getImgLeds(),
            math.floor(ring.x),
            math.floor(ring.y),
            0, 1, 1,
            getImgLeds():getWidth() / 2,
            getImgLeds():getHeight() / 2)

        -- timer:
        gr.draw(timer.img,
            math.floor(timer.x),
            math.floor(timer.y),
            0, 1, 1,
            timer.img:getWidth() / 2,
            timer.img:getHeight() / 2
        )

        -- arc:
        gr.setColor(colors.lightGreen)
        if timer.time <= timer.initTime / 2 then
            gr.setColor(colors.orange)
        end
        if timer.time <= timer.initTime / 4 then
            gr.setColor(colors.red)
        end

        gr.arc(
            "fill",
            math.floor(timer.x), 
            math.floor(timer.y),
            15,
            math.rad(0 + 180),
            math.rad(360 * (timer.time / timer.initTime) + 180),
            80
        )

        -- black center:
        gr.setColor(colors.black)
        gr.circle(
            "fill",
            math.floor(timer.x), 
            math.floor(timer.y),
            10,
            80
        )

        -- time:
        gr.setColor(colors.white)
        local textTime = string.format("%.0f", timer.time)
        gr.print(textTime,
            math.floor(timer.x - font:getWidth(textTime) / 2) - 1,
            math.floor(timer.y - font:getHeight() / 2)
        )

        -- points:
        gr.setColor(colors.black)
        gr.print(
            points,
            math.floor(canvasW / 2 - font:getWidth(tostring(points)) / 2) - 1,
            30
        )
        gr.setColor(colors.white)
        gr.print(
            points,
            math.floor(canvasW / 2 - font:getWidth(tostring(points)) / 2),
            31
        )

        if paused then
            gr.draw(imgGrid, quadGrid, 0, 0)
            gooi.draw("pause")
        end
    elseif state == STATE_GAME_OVER then
        gooi.draw("gameover")
    elseif state == STATE_OPTIONS then
        gooi.draw("options")
    elseif state == STATE_HS then
        gooi.draw("hs")
    elseif state == STATE_DONATIONS then
        gooi.draw("donations")
        gr.setColor(colors.white)
        --gr.draw(imgGmail, 97, lblPaypal.y + 10)
        --gr.draw(imgFB, 97, lblFB.y + 10)
    elseif state == STATE_HELP then
        gooi.draw("help")

        gr.setColor(colors.white)
        gr.draw(imgRedCandy,   20, 25)
        gr.draw(imgGreenCandy, 40, 25)
        gr.draw(imgBlueCandy,  60, 25)

        animSpecial :draw(170, 25)
        animShrinker:draw(190, 25)
        animZG      :draw(210, 25)
    end

    gr.setCanvas()
    gr.setColor(colors.white)
    gr.draw(canvas, 0, 0, 0, sx, sy)

    --gr.print("FPS: "..fps()..", candy: "..#candies, 5, 5)
    gr.setColor(colors.white)
end











--##############################################
--##############################################
-- love api
--##############################################
--##############################################

function love.keypressed(k)
    if k == "escape" and not (dbwc or dbtu) then
        if state == STATE_MENU then
            quit()
        elseif state == STATE_GAME then
            paused = not paused
            gooi.setGroupVisible("pause", paused)
        elseif state == STATE_OPTIONS then
            state = STATE_MENU
            gooi.setGroupVisible("menu", true)
            gooi.setGroupVisible("options", false)
        elseif state == STATE_CREDITS then
            state = STATE_MENU
            gooi.setGroupVisible("menu", true)
            gooi.setGroupVisible("credits", false)
        elseif state == STATE_DONATIONS then
            state = STATE_MENU
            gooi.setGroupVisible("menu", true)
            gooi.setGroupVisible("donations", false)
        elseif state == STATE_HELP then
            state = STATE_MENU
            gooi.setGroupVisible("menu", true)
            gooi.setGroupVisible("help", false)
        end
    end

    if state == STATE_HS then
        gooi.keypressed(k)
    end
end

function love.keyreleased(k)
    if state == STATE_HS then
        gooi.keyreleased(k)
    end
end

function love.textinput(text)
    if state == STATE_HS then
        gooi.textinput(text)
    end
end

function love.mousepressed(x, y, btn)
    if btn == MOUSE_LEFT then
        for k, candy in ipairs(candies) do
            if candy:overIt(mo.getX() / sx, mo.getY() / sy) then
                candy.selected = true
            else
                candy.selected = false
            end
        end
    end

    gooi.pressed()
end

function love.mousemoved(x, y, dx, dy)
    gooi.moved(x, y)
end

function love.mousereleased(x, y, btn)
    if btn == MOUSE_LEFT then
        --debug:
        --ball.body:applyLinearImpulse(ma.random(-500, 500), ma.random(-500, 500))

        local selectedCandy = getSelectedCandy()

        if selectedCandy then
            selectedCandy.body:applyLinearImpulse(
                -(selectedCandy.x - mo.getX() / sx) * selectedCandy.body:getMass() * 6,
                -(selectedCandy.y - mo.getY() / sy) * selectedCandy.body:getMass() * 6
            )
            selectedCandy.selected = false
        end
    end
    
    gooi.released()
end












--##############################################
--##############################################
-- user
--##############################################
--##############################################

function getSelectedCandy()
    for k, candy in ipairs(candies) do
        if candy.selected then
            return candy
        end
    end
end

function getImgLeds()
    local img = imgRedLeds
    ring.state = "red"

    if clock.angle >= 120 then
        img = imgGreenLeds
        ring.state = "green"
    end

    if clock.angle >= 240 then
        img = imgBlueLeds
        ring.state = "blue"
    end

    return img
end

function removeCandyOfColor(color)
    for i = #candies, 1, -1 do
        local candy = candies[i]

        if candy.kind == color then
            candy.body.body:destroy()
            table.remove(candies, i)
        end
    end
end

function shrinkAll()
    for k, candy in ipairs(candies) do
        candy.small = true
        -- backup current velocity:
        local vx, vy = candy.body.body:getLinearVelocity();

        candy.body.body:destroy()
        candy.body = lope.newBody("dynamic", "circle", candy.x, candy.y, crSmall)
        candy.body.body:setLinearVelocity(vx, vy)
    end
end

function changeMusicLevel(level)
    musicMenu:setVolume(level)
    musicGame:setVolume(level)
    musicGameOver:setVolume(level)
end

function changeSFXLevel(level)
    soundDBWC:setVolume(level)
    soundPoint:setVolume(level)
    soundZG:setVolume(level)
    soundShrinker:setVolume(level)
    soundSpecial:setVolume(level)
end

function gameover(flagAbsoluteGameOver)
    if flagAbsoluteGameOver or (points < minimumForHighScore) then
        state = STATE_GAME_OVER
        points = 0
    else
        state = STATE_HS
        gooi.setGroupVisible("hs", true)
        gooi.setGroupVisible("pause", false)

        recordToSet = nil
        local indexPlace = 1
        for k, rec in ipairs(records) do
            if rec.score <= points then
                recordToSet = rec
                break
            end
            indexPlace = indexPlace + 1
        end

        if not recordToSet then -- reached the minimum, but is less than 4th place:
            gameover(true)
        end

        lblPlace:setText(indexPlace..places[indexPlace].." place!")
        lblPoints:setText("score: "..points)
    end

    clearStuff()
    musicGame:stop()
    musicGameOver:play()
end

function clearStuff()
    for i = #candies, 1, -1 do
        local candy = candies[i]

        candy.body.body:destroy()
        table.remove(candies, i)
    end
    candiesBeingEaten = {}

    timer.time = timer.initTime
    clock.angle = 0
    hp = initHP
    yQuadHearts = 0
    quadHearts:setViewport(0, 0,
        23, 7,
        imgHearts:getWidth(),
        imgHearts:getHeight()
    )

    randomSpecialItem()
    indexCandy = 0
    delayEnterCandy = initDelayEnterCandy
    timerZeroGrav = 0
    timerDBWC = 0
    timerScoreScreen = 0
    timerGameOver = 0
    timerMoveTitle = 0
    zeroGravActivated = false
    zeroGravActivated = false
    dbwc = false
    dbtu = false
    WORLD:setGravity(
        WORLD_GRAVITY.x * WORLD_METER,
        WORLD_GRAVITY.y * WORLD_METER
    )
end

function saveRecords(r)
    local stringData = "records = {\n"

    for k, rec in ipairs(r) do
        stringData = stringData..
        "    {\n"..
        "        score = "..(rec.score)..",\n"..
        "        name = \""..(rec.name).."\"\n"..
        "    },"
    end

    stringData = stringData.."\n}"
    local compressedData = ma.compress(stringData, "gzip")
    local writeOK = fs.write(fileNameHS, compressedData)
end

function getTextHSNames()
    local text = ""

    local dataHighScores, size = fs.read(fileNameHS)
    decompressed = ma.decompress(dataHighScores, "gzip")

    load(decompressed)() --<<----- stored in global "records"

    local index = 1
    for k, rec in ipairs(records) do
        text = text..
        index.." "..rec.name.."\n"
        index = index + 1
    end

    return text
    --[[
    local text = ""
    local data, size = fs.read(fileNameHS)

    loadstring(data)()

    local index = 1
    for k, rec in ipairs(records) do
        text = text..
        index..places[index].." "..rec.name.."\n"
        index = index + 1
    end

    return text
    ]]

end

function getTextHS()
    local text = ""

    for k, rec in ipairs(records) do
        text = text..rec.score.."\n"
    end

    return text
    --[[
    local text = ""

    for k, rec in ipairs(records) do
        text = text..rec.score.."\n"
    end

    return text
    ]]
end

function randomSpecialItem()
    howManyToSpecial = ma.random(8, 16)
end

function zeroGrav()
    WORLD:setGravity(0, 0)
    zeroGravActivated = true
    timerZeroGrav = 0
end

function fps()
    return love.timer.getFPS()
end

function r(min, max)
    return love.math.random(min or 0, max or 255)
end

function quit()
    love.event.quit()
end
